//package chordbook;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.color.*;
import java.lang.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.awt.event.*;


public class ChordBook extends JFrame implements ListSelectionListener {
    
    private Container container;
    private GridBagConstraints constraints; 
    private JList SongList;       // list of song titles
    private Vector Olist;       // list of vectors of song objects
    private JTextPane SongText;
    private JLabel SongHeaderArtist;    // Header - artist and title on top
    private JLabel SongHeaderTitle;
    private JPanel header;        // header with title and artist
    private JList Echords; // chordlist
    private ChordDB ChordDB; // create ChordDB window
    
    ChordBook() {
        // Do low-level parse on songs in repository and make songlist
        ImportSongList();
        // Format main interface

        ChordBookInterface();
        //setJMenuBar(new ChordBookMenu());
    }
    
    
    /*
     *  Main Method
     */
    
    void ChordBookInterface() {
        
        container = getContentPane(); // Main container of GUI objects

        BorderLayout layout = new BorderLayout(); // setting layout
        container.setLayout( layout );   

        constraints = new GridBagConstraints();

        // setting 3 main panels with 1 sub-panel:
        
        JPanel west = new JPanel();
        
        JPanel centre = new JPanel();
            header = new JPanel(); // panel for artist and title
            
            
        JPanel east = new JPanel();
        
        // Setting WEST panel
        west.setLayout(new BorderLayout());
        west.setMinimumSize(new Dimension(100, 100)); //ex 100, 50
        JTextField search = new JTextField ("asdf", 30);
        west.add(search, BorderLayout.NORTH);
        
                JScrollPane SCROLLlist = new JScrollPane( SongList );
        
        // adding file list
        
        west.add(SCROLLlist, BorderLayout.CENTER);

        centre.setLayout(new BorderLayout());
        centre.setMinimumSize(new Dimension(200, 50));
        
        // Creating HEADER with song ARTIST and TITLE
        header.setLayout(new BorderLayout());
        header.setMinimumSize(new Dimension(200, 50));
        
        SongHeaderArtist = new JLabel("[SongHeaderArtist]");
        SongHeaderTitle = new JLabel("[SongHeaderTitle]");
        
        SongHeaderTitle.setFont(new Font("Trebuchet MS", Font.PLAIN, 20));
        
        header.add(SongHeaderArtist, BorderLayout.NORTH);
        header.add(SongHeaderTitle, BorderLayout.SOUTH);
        
        centre.add(header, BorderLayout.NORTH);

        SongText = new JTextPane ();
        SongText.setMinimumSize ( new Dimension(200, 300) );
        
        SongText.setFont(new Font("Courier", Font.PLAIN, 12));

        JScrollPane song = new JScrollPane(SongText);
        centre.add(song, BorderLayout.CENTER);
        JSplitPane sepmain = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, west, centre);
        sepmain.setContinuousLayout(true);
        sepmain.setDividerSize(1);
        sepmain.setDividerLocation(200);
        sepmain.setMinimumSize(new Dimension(500, 25));

        east.setLayout(new FlowLayout());
        east.setPreferredSize(new Dimension(100, 50));
        east.setMaximumSize(new Dimension(100, 50));
        JLabel Elabel = new JLabel("Chords:");
        //JLabel Efoo  = new JLabel("Fm7 [133211]");
        Echords = new JList();

        east.add(Elabel);
        //east.add(Efoo);
        east.add(Echords);

        container.add(east, BorderLayout.EAST);
        container.add(sepmain, BorderLayout.CENTER);

        this.pack();

        setSize( 700, 500 );
        openSong( 0 ); // initialze first song.
        
        setVisible( true );
        
    }
    
    void ImportSongList() {
        // Import Song List

        getDirContents dir = new getDirContents();  // new directory handler

        Olist = dir.getDir();
        SongList = new JList(Olist);
        
        SongList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION); // single selection only
        SongList.setSelectedIndex(0);
        SongList.addListSelectionListener(this);
        
    }

    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting())
            return;

        JList theList = (JList)e.getSource();
        if (theList.isSelectionEmpty()) {
            System.out.println("Selection empty");
        } else {
            int index = SongList.getSelectedIndex();
            openSong(index);
            
        }
    }
    
     /*
     * Procedure called upon selection from songlist
     * Gets tags from object array and sets to header
     * Open file and sets to SongText.
     */
    void openSong(int ID) {
        
        Song SelectedSong = (Song)Olist.elementAt(ID);
        try {
            // Display formatted text
            SongText.setDocument ( SelectedSong.getDocument() );
            //ImportChordList ( SelectedSong.ChordList );
            System.out.println("Setting song: "+ID);
        } catch (Exception e) { 
            System.out.println("Cannot parse song: "+e); }
        
        //if((SelectedSong.ARTIST).compareTo(null)!=0) 
            SongHeaderArtist.setText( SelectedSong.ARTIST );
        //if((SelectedSong.TITLE).compareTo(null)!=0) 
            SongHeaderTitle.setText ( SelectedSong.TITLE );
        
    }
    
    /*void ImportChordList (LinkedChordList ChordList) {
        Chord foo = new Chord();
        while (foo != null) {
            
        }
    }*/
    
}
