/*
 * Class: ChordBookInterface
 *
 * Main application window with methods for user interaction.
 *
 */

import java.awt.Dimension;
import java.awt.Rectangle;
import java.util.Vector;
import javax.swing.DefaultListModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.text.*;

public class ChordBookInterface extends javax.swing.JFrame {
    
    /** Creates new form ChordBookInterface */
    public ChordBookInterface() {
        initComponents();

        setJMenuBar(ChordBookMenu.getInstance());

        Dimension dim = getToolkit().getScreenSize();
        Rectangle abounds = getBounds();
        this.setLocation((dim.width - abounds.width) / 2, (dim.height - abounds.height) / 2);
        
    }
    
    public static ChordBookInterface getInstance() {
        return ChordBookInterfaceHolder.instance;
    }
    
    private static class ChordBookInterfaceHolder {
        private static ChordBookInterface instance = new ChordBookInterface();
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        SearchPanel = new javax.swing.JPanel();
        SearchField = new javax.swing.JTextField();
        SearchLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        HeaderPanel = new javax.swing.JPanel();
        ArtistLabel = new javax.swing.JLabel();
        TitleLabel = new javax.swing.JLabel();
        ContentPane = new javax.swing.JSplitPane();
        SongAndChordListPane = new javax.swing.JSplitPane();
        SongListScroll = new javax.swing.JScrollPane();
        SongList = new javax.swing.JList();
        ChordListScroll = new javax.swing.JScrollPane();
        ChordTable = new javax.swing.JTable();
        SongTextScroll = new javax.swing.JScrollPane();
        SongText = new javax.swing.JTextPane();
        ActionsPanel = new javax.swing.JPanel();
        AddButton = new javax.swing.JButton();
        SaveButton = new javax.swing.JButton();
        DeleteButton = new javax.swing.JButton();
        ActionsLabel = new javax.swing.JLabel();
        TransposePanel = new javax.swing.JPanel();
        TranspSlider = new javax.swing.JSlider();
        TranspDownLabel = new javax.swing.JLabel();
        TranspUpLabel = new javax.swing.JLabel();
        TranspLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Chord Book");
        setName("ChordBookFrame");
        SearchField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                SearchFieldKeyReleased(evt);
            }
        });

        SearchLabel.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        SearchLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        SearchLabel.setText("Search");

        jLabel1.setIcon(new javax.swing.ImageIcon("/Users/einis/Mokykla/CS/ChordBook/ChordBook/icons/system-search.png"));

        org.jdesktop.layout.GroupLayout SearchPanelLayout = new org.jdesktop.layout.GroupLayout(SearchPanel);
        SearchPanel.setLayout(SearchPanelLayout);
        SearchPanelLayout.setHorizontalGroup(
            SearchPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(SearchPanelLayout.createSequentialGroup()
                .add(jLabel1)
                .add(0, 0, 0)
                .add(SearchPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, SearchLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 214, Short.MAX_VALUE)
                    .add(SearchField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 214, Short.MAX_VALUE)))
        );
        SearchPanelLayout.setVerticalGroup(
            SearchPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(SearchPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(SearchPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(SearchField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(SearchLabel)
                .addContainerGap(23, Short.MAX_VALUE))
        );

        ArtistLabel.setFont(new java.awt.Font("Lucida Grande", 0, 18));
        ArtistLabel.setText("The Artist");

        TitleLabel.setFont(new java.awt.Font("Lucida Grande", 0, 22));
        TitleLabel.setText("The Title");

        org.jdesktop.layout.GroupLayout HeaderPanelLayout = new org.jdesktop.layout.GroupLayout(HeaderPanel);
        HeaderPanel.setLayout(HeaderPanelLayout);
        HeaderPanelLayout.setHorizontalGroup(
            HeaderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(HeaderPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(HeaderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(ArtistLabel)
                    .add(TitleLabel))
                .addContainerGap(432, Short.MAX_VALUE))
        );
        HeaderPanelLayout.setVerticalGroup(
            HeaderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(HeaderPanelLayout.createSequentialGroup()
                .add(ArtistLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(TitleLabel)
                .addContainerGap(23, Short.MAX_VALUE))
        );

        ContentPane.setBorder(null);
        ContentPane.setDividerLocation(Integer.parseInt(Config.getValue("splitpos_content")));
        ContentPane.setContinuousLayout(true);
        ContentPane.setMinimumSize(new java.awt.Dimension(200, 200));
        ContentPane.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                ContentPanePropertyChange(evt);
            }
        });

        SongAndChordListPane.setBorder(null);
        SongAndChordListPane.setDividerLocation(Integer.parseInt(Config.getValue("splitpos_songchord")));
        SongAndChordListPane.setDividerSize(3);
        SongAndChordListPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        SongAndChordListPane.setContinuousLayout(true);
        SongAndChordListPane.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                SongAndChordListPanePropertyChange(evt);
            }
        });

        SongList.setModel(SongListModel);
        SongList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                SongListValueChanged(evt);
            }
        });

        SongListScroll.setViewportView(SongList);

        SongAndChordListPane.setTopComponent(SongListScroll);

        ChordTable.setModel(ChordTableModel);
        ChordListScroll.setViewportView(ChordTable);

        SongAndChordListPane.setRightComponent(ChordListScroll);

        ContentPane.setLeftComponent(SongAndChordListPane);

        SongText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                SongTextKeyPressed(evt);
            }
        });

        SongTextScroll.setViewportView(SongText);

        ContentPane.setRightComponent(SongTextScroll);

        AddButton.setIcon(new javax.swing.ImageIcon("./icons/document-open.png"));
        AddButton.setText("Add...");
        AddButton.setToolTipText("Add new file to the library");

        SaveButton.setIcon(new javax.swing.ImageIcon("./icons/document-save.png"));
        SaveButton.setText("Save");
        SaveButton.setToolTipText("Save changes");
        SaveButton.setEnabled(false);
        SaveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveButtonActionPerformed(evt);
            }
        });

        DeleteButton.setIcon(new javax.swing.ImageIcon("./icons/edit-delete.png"));
        DeleteButton.setText("Delete");
        DeleteButton.setToolTipText("Delete selected song");

        ActionsLabel.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        ActionsLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        ActionsLabel.setText("Actions");

        org.jdesktop.layout.GroupLayout ActionsPanelLayout = new org.jdesktop.layout.GroupLayout(ActionsPanel);
        ActionsPanel.setLayout(ActionsPanelLayout);
        ActionsPanelLayout.setHorizontalGroup(
            ActionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(ActionsLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE)
            .add(ActionsPanelLayout.createSequentialGroup()
                .add(AddButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(SaveButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(DeleteButton))
        );
        ActionsPanelLayout.setVerticalGroup(
            ActionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(ActionsPanelLayout.createSequentialGroup()
                .add(ActionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(AddButton)
                    .add(SaveButton)
                    .add(DeleteButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(ActionsLabel))
        );

        TranspSlider.setMajorTickSpacing(1);
        TranspSlider.setMaximum(12);
        TranspSlider.setMinimum(-12);
        TranspSlider.setMinorTickSpacing(1);
        TranspSlider.setPaintTicks(true);
        TranspSlider.setSnapToTicks(true);
        TranspSlider.setToolTipText("Shift song key");
        TranspSlider.setValue(0);
        TranspSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                TranspSliderStateChanged(evt);
            }
        });

        TranspDownLabel.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        TranspDownLabel.setIcon(new javax.swing.ImageIcon("./icons/list-remove.png"));

        TranspUpLabel.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        TranspUpLabel.setIcon(new javax.swing.ImageIcon("./icons/list-add.png"));

        TranspLabel.setFont(new java.awt.Font("Lucida Grande", 0, 10));
        TranspLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        TranspLabel.setText("Transpose (0)");

        org.jdesktop.layout.GroupLayout TransposePanelLayout = new org.jdesktop.layout.GroupLayout(TransposePanel);
        TransposePanel.setLayout(TransposePanelLayout);
        TransposePanelLayout.setHorizontalGroup(
            TransposePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(TransposePanelLayout.createSequentialGroup()
                .add(TranspDownLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(TranspSlider, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 347, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(TranspUpLabel))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, TranspLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 355, Short.MAX_VALUE)
        );
        TransposePanelLayout.setVerticalGroup(
            TransposePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(TransposePanelLayout.createSequentialGroup()
                .add(TransposePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(TranspSlider, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(TranspDownLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                    .add(TranspUpLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE))
                .add(1, 1, 1)
                .add(TranspLabel))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(SearchPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(HeaderPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(ActionsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 183, Short.MAX_VALUE)
                .add(TransposePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .add(ContentPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 815, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, HeaderPanel, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, SearchPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(ContentPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 487, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(TransposePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(ActionsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void SongListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_SongListValueChanged
        openSong((Song) SongList.getSelectedValue());
    }//GEN-LAST:event_SongListValueChanged
    
    private void openSong(Song s) {
        // Disable Save button
        SaveButton.setEnabled(false);
        
        // Set document to main text areSong Song object:
        SongText.setDocument(s.getDocument());
        
        // Set labels from Song tags:
        ArtistLabel.setText(s.ARTIST);
        TitleLabel.setText(s.TITLE);
        
        ReFillChordTable(s.ChordList);
    }
    
    private void ReFillChordTable(LinkedChordList list) {
        // Set chords from linked chord list at Song object to chord table
        ChordTableModel.dropContents(); // drop contents if any of previous song

        LChord CurrentNode = new LChord();
        CurrentNode = list.first;

        while(CurrentNode != null) {
            ChordTableModel.addChord(CurrentNode.chord);
            CurrentNode = CurrentNode.next;
        }
    }
    
    private void SearchFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_SearchFieldKeyReleased
        // Instant search implementation, case insensitive!
        
        String value = SearchField.getText();
        value=value.toLowerCase(); // LowerCase search string, song title is also LowerCase
        ReFillSongList(Songs);     // Fill SongList with full list on every keystroke

        if (value.compareTo("")!=0) { // empty search string returns full list
            int size = SongListModel.size();
            
            for (int i=0;i<size;i++) {
                if( SongListModel.getElementAt(i).toString().toLowerCase().indexOf(value) < 0 ) {
                    SongListModel.removeElementAt(i);
                    i--;    // Removal shrinks array, thus going one step backwards
                    size--; // Decrasing size value
                }
            }
        }
    }//GEN-LAST:event_SearchFieldKeyReleased

    private void ContentPanePropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_ContentPanePropertyChange
        if (!evt.getNewValue().equals("true") || !evt.getNewValue().equals("false"))
            Config.setValue("splitpos_content",ContentPane.getDividerLocation());
    }//GEN-LAST:event_ContentPanePropertyChange

    private void SongAndChordListPanePropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_SongAndChordListPanePropertyChange
        if (!evt.getNewValue().equals("true") || !evt.getNewValue().equals("false"))
            Config.setValue("splitpos_songchord",SongAndChordListPane.getDividerLocation());
    }//GEN-LAST:event_SongAndChordListPanePropertyChange

    private void SongTextKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_SongTextKeyPressed
        // Activate SAVE button and SAVE menu item when edited
        SaveButton.setEnabled(true);
        ChordBookMenu.getInstance().SaveItemState(true);
    }//GEN-LAST:event_SongTextKeyPressed

    private void TranspSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_TranspSliderStateChanged
        // Transpose
        TranspLabel.setText("Transpose ("+TranspSlider.getValue()+")");
        Song SelectedSong = (Song) SongList.getSelectedValue();
        SongText.setDocument(SelectedSong.getDocument(TranspSlider.getValue()));
        
        ReFillChordTable(SelectedSong.ChordList);
    }//GEN-LAST:event_TranspSliderStateChanged

    private void SaveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveButtonActionPerformed
        SaveOpenedSong();
    }//GEN-LAST:event_SaveButtonActionPerformed
    
    public void SaveOpenedSong() {
        // Disable button and menu item
        SaveButton.setEnabled(false);
        ChordBookMenu.getInstance().SaveItemState(false);
        
        // Write document
        Song current = (Song) SongList.getSelectedValue();
        current.saveDocument(SongText.getDocument());
    }
    
    public void EditTags() {
        Song current = (Song) SongList.getSelectedValue();
        TagEditor tags = new TagEditor(current);
    }
    public void WrapText(boolean status) {
        Alert.INFO("Foo: "+status);
    }
    
    // this method is called BEFORE show() and only once,
    // thus Vector Songs is always with some data
    public void PublishSongList(Vector songs) {
        Songs = new Vector(songs); // creating backup
                
        ReFillSongList(songs);
        
        // open first song and place selection on the list
        openSong((Song) Songs.elementAt(0));
        SongList.setSelectedIndex(0);
    }
    
    private void ReFillSongList(Vector songs) {
        SongListModel.removeAllElements();
        for(int i=0;i<songs.size();i++)
            SongListModel.add(i, songs.get(i));
        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ChordBookInterface().setVisible(true);
            }
        });
    }
    private DefaultListModel SongListModel = new DefaultListModel();
    private ChordTableModel ChordTableModel = new ChordTableModel();
    private Vector Songs = new Vector();
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel ActionsLabel;
    private javax.swing.JPanel ActionsPanel;
    private javax.swing.JButton AddButton;
    private javax.swing.JLabel ArtistLabel;
    private javax.swing.JScrollPane ChordListScroll;
    private javax.swing.JTable ChordTable;
    private javax.swing.JSplitPane ContentPane;
    private javax.swing.JButton DeleteButton;
    private javax.swing.JPanel HeaderPanel;
    private javax.swing.JButton SaveButton;
    private javax.swing.JTextField SearchField;
    private javax.swing.JLabel SearchLabel;
    private javax.swing.JPanel SearchPanel;
    private javax.swing.JSplitPane SongAndChordListPane;
    private javax.swing.JList SongList;
    private javax.swing.JScrollPane SongListScroll;
    private javax.swing.JTextPane SongText;
    private javax.swing.JScrollPane SongTextScroll;
    private javax.swing.JLabel TitleLabel;
    private javax.swing.JLabel TranspDownLabel;
    private javax.swing.JLabel TranspLabel;
    private javax.swing.JSlider TranspSlider;
    private javax.swing.JLabel TranspUpLabel;
    private javax.swing.JPanel TransposePanel;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables
    
}
