/*
 *  Class: Main
 *
 *  Start-up class. Must be run first.
 *
 */
public class Main {
    
    public static void main(String[] args) {
        
        // Settings for Mac OS X
        
        if(System.getProperty("os.name").equals("Mac OS X")) {
            System.setProperty("apple.laf.useScreenMenuBar","true"); // top-screen menubar
            System.setProperty("apple.awt.brushMetalLook","true");
            System.setProperty("com.apple.mrj.application.apple.menu.about.name","Chord Book"); // proper app name
            new MacOSAboutHandler();
            new MacOSPrefsHandler();

        }
       
        Loader loader = new Loader();
        
        ChordBookInterface AppWindow = ChordBookInterface.getInstance();
        
        if(loader.finished) {
            AppWindow.PublishSongList(loader.getSongList());
            
            AppWindow.show();
        }
        else
            Alert.ERROR("Loading error");
    }
    
}

