import java.io.*;     // for
import java.util.*;   //   parsing

import javax.swing.text.*; // for Document
import java.awt.event.*;
import java.awt.color.*;
import java.awt.*;

// chord parser
class parseSong {
    
    final static int START = 0;
    final static int BASE = 1;
    final static int SHIFT = 2;
    final static int EXTRA = 3;
    final static int STOP = 4;
    final static int NOT_CHORD = -1;
    final static int CHORD = -2;
    public MyStyleContext Styles;
    Document doc;
    public LinkedChordList ChordList;
    public LinkedChordList OriginalChordList;
    
    public parseSong(String FILENAME, int TRANSP) throws IOException {
        Alert.WARNING("thou shalt not be executed!");
        ChordList = new LinkedChordList();
        OriginalChordList = new LinkedChordList();
        
        // Creating Stylesheet for document
        Styles = new MyStyleContext();
        
        // Creating document with Stylesheet
        doc = new DefaultStyledDocument(Styles);

        BufferedReader input = new BufferedReader(new FileReader(Config.getValue("library")+"/"+FILENAME));
        String line;
        StringTokenizer st;
        int linetype, lineN;
        lineN = 0;

        while ((line = input.readLine())!= null) {

            lineN++;
            st = new StringTokenizer(line);
            linetype = 0;
            String chLine = new String();
            while (st.hasMoreTokens()) {
                String tmp=st.nextToken();
                //String t = tmp.toUpperCase();
                String t = tmp;

                int state=START;
                Chord temp = new Chord();
                int p=0;
                while (p<t.length() && state != NOT_CHORD) {
                    char token=t.charAt(p);
                    switch(token) {
                        case 'A':
                        case 'B':
                        case 'C':
                        case 'D':
                        case 'E':
                        case 'F':
                        case 'G': if (state==START) {
                                    state = BASE;
                                    temp.base = t.substring(0,1);
                                    p++;
                                  }				 		
                                  else state=NOT_CHORD;
                                  break;
                        case '#':
                        case 'b': if (state==BASE) {
                                    state = SHIFT;
                                    temp.base = temp.base+token;
                                    p++;
                                  }
                                  else state=NOT_CHORD;
                                  break;
                        case 'm':
                        case 'M':
                        case '6':
                        case '7': if (state==BASE || state==SHIFT) {
                                        if (p+4<=t.length() && t.substring(p,p+4).compareTo("Maj7") == 0) {
                                            //System.out.println(t.substring(p,p+4));
                                            temp.extra = t.substring(p,p+4);
                                            p=p+4;
                                            state = EXTRA;
                                        }
                                        else if (p+3<=t.length() && t.substring(p,p+3).compareTo("Maj") == 0) {
                                            temp.extra = t.substring(p,p+3);
                                            p=p+3;
                                            state = EXTRA;
                                        }
                                        else if (p+2<=t.length() && 
                                                        (t.substring(p,p+2).compareTo("Mm") == 0 ||
                                                         t.substring(p,p+2).compareTo("m7") == 0)) {
                                            temp.extra = t.substring(p,p+2);
                                            p=p+2;
                                            state = EXTRA;
                                        }
                                        else if (p+1<=t.length() && (
                                                         t.substring(p,p+1).compareTo("m") == 0 ||
                                                         t.substring(p,p+1).compareTo("6") == 0 ||
                                                         t.substring(p,p+1).compareTo("7") == 0)) {
                                            temp.extra = t.substring(p,p+1);
                                            p=p+1;
                                            state = EXTRA;
                                        }
                                        else state = NOT_CHORD;
                                      }	
                                      else state = NOT_CHORD;
                                      break;
                            case 'a':
                            case 's': if ((state==BASE || state==SHIFT || state==EXTRA) &&
                                                        p+4<=t.length() && 
                                                        ((t.substring(p,p+4).compareTo("add5") == 0 ||
                                                            t.substring(p,p+4).compareTo("sus4") == 0))) {
                                            temp.extra = temp.extra + t.substring(p,p+4);
                                            p=p+4;
                                            state = STOP;
                                      }
                                      else state = NOT_CHORD;
                                      break;
                            default: state = NOT_CHORD;			
                    }
                } // chord catch
             
                if (state != NOT_CHORD && state != START) 
                 // IF chordTest passed AND line had been read
                {
                    linetype = CHORD;
                    line=line.replaceFirst(temp.toString(), temp.transpose(TRANSP).toString());
                    
                    ChordList.add(temp); // adding chord to linked list
                }
                else 
                    linetype = NOT_CHORD;

            }
            
           // printing LINE to document:
            if (linetype == CHORD) 
               printDoc(doc, line, Styles.getStyle("CHORD"));
            else if (!line.startsWith("["))
               printDoc(doc, line, Styles.getStyle("TEXT"));
            
        }

        input.close();
  
        // SONG PARSED.
        ChordList.print();
    }

    private void printDoc(Document doc, String s, Style style) {
        try {
            doc.insertString(doc.getLength(), s+"\n", style);
        } catch (Exception e) { /* need some error msg here */ }
    }
    
}